#include "StdAfx.h"
#include "TsConverter.h"

//////////////////////////////////////////////////////////////////////////////
//FFMPEGN֘A

STARTUPINFO ffmpeg_si;
PROCESS_INFORMATION ffmpeg_pi;

bool OpenFFmpeg(LPWSTR vlc)
{
	// ffmpeg̋NB
	::ZeroMemory(&ffmpeg_si, sizeof(STARTUPINFO));
	ffmpeg_si.cb           = sizeof(STARTUPINFO);
	ffmpeg_si.dwFlags      = 0;//STARTF_USESTDHANDLES;
	ffmpeg_si.wShowWindow  = SW_SHOWNORMAL;

	ffmpeg_si.hStdError = GetStdHandle(STD_ERROR_HANDLE);
	ffmpeg_si.hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);
	ffmpeg_si.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
	
	int ret = ::CreateProcess(NULL, vlc, NULL, NULL, FALSE, /*DETACHED_PROCESS*/0, NULL, NULL, &ffmpeg_si, &ffmpeg_pi);

	return TRUE;
}

void CloseFFmpeg(void)
{
	if(::WaitForSingleObject(ffmpeg_pi.hProcess, 0) == WAIT_TIMEOUT){
//		log_out("ffmpeg̏I҂Ă܂B\n");
		::WaitForSingleObject(ffmpeg_pi.hProcess, INFINITE);
//		log_out("ffmpegIB\n");
	}
}



CTsConverter::CTsConverter(IEventHandler *pEventHandler)
	: m_pEventHandler(pEventHandler)
	, m_FileReader(this)
	, m_TsPacketParser(this)
	, m_ProgManager(this)
	, m_TsDescrambler(this)
	, m_VideoFile(this)
	, m_AudioFile(this)
	, m_AacConverter(this)
	, m_WaveWriter(this)
{
	m_AudHoseiFromVid = FALSE;
	m_pWaveSend = NULL;
	m_pVideoSend = NULL;
	
	m_pVideoBand = NULL;
	m_pAudioBand = NULL;

	m_pTsDemuxer = NULL;
}

CTsConverter::~CTsConverter(void)
{
	CancelConvert();
}

static const BYTE WaveHead[] =		// from CWaveWriter@BonTsDemux
{
	'R', 'I', 'F', 'F',				// +0	RIFF
	0x00U, 0x00U, 0x00U, 0x00U,		// +4	ȍ~̃t@CTCY(t@CTCY - 8)
	'W', 'A', 'V', 'E',				// +8	WAVE
	'f', 'm', 't', ' ',				// +12	fmt
	0x10U, 0x00U, 0x00U, 0x00U,		// +16	fmt `ÑoCg
	0x01U, 0x00U,					// +18	tH[}bgID
	0x02U, 0x00U,					// +20	XeI
	0x80U, 0xBBU, 0x00U, 0x00U,		// +24	48KHz
	0x00U, 0xEEU, 0x02U, 0x00U,		// +28	192000Byte/s
	0x04U, 0x00U,					// +30	ubNTCY
	0x10U, 0x00U,					// +32	Tṽrbg
	'd', 'a', 't', 'a',				// +36	data
	0x00U, 0xffU, 0xffU, 0xffU		// +40	g`f[^̃oCg
};

const bool CTsConverter::ConvertTsFile(LPCTSTR lpszTsFile, LPCTSTR lpszVideoFile, LPCTSTR lpszAudioFile, const bool bDecodeAac, const bool bLipSync,LPCTSTR ffmpeg_param)
{
/* 
	|AACfR[hȂ|
	m_FileReader  [m_TsPacketParser]  m_TsDescrambler  m_ProgManager  m_TsDemuxer  m_VideoFile
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ m_AudioFile
	|AACfR[h|
	m_FileReader  [m_TsPacketParser]  m_TsDescrambler  m_ProgManager  m_TsDemuxer  m_VideoFile
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ m_AacConverter  m_WaveWriter
*/

	// fR[_UN[Y
	CloseDecoders();

	try{
		// TSt@CJ
		if(!m_FileReader.OpenFile(lpszTsFile))throw 0UL;
		m_pTsDemuxer = new CTsDemuxer(this);

		if(ffmpeg_param[0] == NULL){

			if(!m_VideoFile.OpenFile(lpszVideoFile))throw 1UL;
			m_pTsDemuxer->SetOutputDecoder(&m_VideoFile, CTsDemuxer::OUTPUT_VIDEO);

			if(!m_WaveWriter.OpenFile(lpszAudioFile))throw 2UL;
			m_AacConverter.SetOutputDecoder(&m_WaveWriter);
			m_pTsDemuxer->SetOutputDecoder(&m_AacConverter, CTsDemuxer::OUTPUT_AUDIO);
		} else {

			m_pVideoBand = new CKeepRate(64*1024,			//packet
											0,				//margin
											20*1024*1024,	//max
											0,	//max_bps
											TRUE,			//copydata
											L"M2V",			//name
											this);	//VIDEOpNbVobt@
			m_pVideoSend = new CHttpSend(this,1234,64*1024);
				
			m_pTsDemuxer->SetOutputDecoder(m_pVideoBand, CTsDemuxer::OUTPUT_VIDEO);
			m_pVideoBand->SetOutputDecoder(m_pVideoSend);

			m_pTsDemuxer->SetOutputDecoder(&m_AacConverter, CTsDemuxer::OUTPUT_AUDIO);

			m_pAudioBand = new CKeepRate(1024*64,		//packet
												0,		//margin
												10*1024*1024,		//max
												0,		//max_bps
												TRUE,	//copydata
												L"WAV",	//name
												this);	//AudiopNbVobt@
			m_AacConverter.SetOutputDecoder(m_pAudioBand);

			m_pWaveSend = new CHttpSend(this,1234,64*1024);
			m_pAudioBand->SetOutputDecoder(m_pWaveSend);

			CMediaData *m = new CMediaData(WaveHead, (DWORD)sizeof(WaveHead));
			m_pWaveSend->InputMedia(m);
			delete m;
		}


		// B-CASJ[hp\ȂƂTSfXNuڑ
		if(m_TsDescrambler.OpenBcasCard()){
			// B-CASJ[hp\
			m_TsPacketParser.SetOutputDecoder(&m_TsDescrambler);
			m_TsDescrambler.SetOutputDecoder(&m_ProgManager);	
			}
		else{
			// B-CASJ[hps
			m_TsPacketParser.SetOutputDecoder(&m_ProgManager);
			}

		// fR[_Otڑ
		m_FileReader.SetOutputDecoder(&m_TsPacketParser);
		m_ProgManager.SetOutputDecoder(m_pTsDemuxer);
		m_pTsDemuxer->EnableLipSync(bLipSync);
		}
	catch(DWORD dwErrorCode){
		// G[
		CloseDecoders();
		return false;
		}
	if(ffmpeg_param[0] != NULL){

		wchar_t szModulePath[256],drv[10],path[256],ext[256],appname[256],execname[256];
		wchar_t enc_param[256];
		enc_param[0] = NULL;
		GetModuleFileName(NULL,szModulePath,256);
		_wsplitpath(szModulePath,drv,path,appname,ext);
		_wmakepath(execname,drv,path,L"ffmpeg",L"exe");


		CString arg;
		arg = ffmpeg_param;
		arg = L" -i \"http://localhost:1234/video.m2v\" -i \"http://localhost:1234/audio.wav\" " + arg;
		arg = L"\"" + arg;
		arg = execname + arg;
		arg = L"\"" + arg;

		if(lpszVideoFile){
			arg = arg + L" \"";
			arg += lpszVideoFile;
			arg = arg + L"\"";
		} else {
			arg = arg + L" testout.mpg";
		}
		OpenFFmpeg(arg.GetBuffer());

		m_pVideoSend->IsOpen();
	}


	// fR[_OtZbg
	m_FileReader.Reset();
	
	// Ro[gJn
	return m_FileReader.StartReadAnsync();
}

void CTsConverter::CancelConvert(void)
{
	// Ro[g~
	m_FileReader.StopReadAnsync();
}

void CTsConverter::CloseDecoders(void)
{
	// fR[_
	m_TsDescrambler.CloseBcasCard();
	m_FileReader.CloseFile();
	m_VideoFile.CloseFile();
	m_AudioFile.CloseFile();
	m_WaveWriter.CloseFile();

	while((m_pVideoBand && m_pVideoBand->m_bThreadIdle == FALSE) && (m_pAudioBand && m_pAudioBand->m_bThreadIdle == FALSE)){
		Sleep(100);
	}

	if(m_pVideoBand)	m_pVideoBand->StopTrans();
	if(m_pAudioBand)	m_pAudioBand->StopTrans();

	if(m_pWaveSend)	m_pWaveSend->Close();
	if(m_pVideoSend)	m_pVideoSend->Close();

	if(m_pVideoBand)	delete m_pVideoBand;
	if(m_pAudioBand) 	delete m_pAudioBand;
	
	if(m_pWaveSend)		delete m_pWaveSend;
	if(m_pVideoSend)	delete m_pVideoSend;

	if(m_pTsDemuxer)	delete m_pTsDemuxer;

	m_pWaveSend = NULL;
	m_pVideoSend = NULL;

	m_pVideoBand = NULL;
	m_pAudioBand = NULL;

	m_pTsDemuxer = NULL;

	CloseFFmpeg();
}

const DWORD CTsConverter::OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam)
{
	// fR[_̃Cxg󂯎(b)
	if(pDecoder == &m_ProgManager){
		
		// vO}l[W̃Cxg
		switch(dwEventID){
			case CProgManager::EID_SERVICE_LIST_UPDATED : {
				// T[rX̍\ω
				WORD wVideoPID = 0xFFFF;
				WORD wAudioPID = 0xFFFF;
				m_ProgManager.GetServiceEsPID(&wVideoPID, &wAudioPID);
				m_pTsDemuxer->SetVideoPID(wVideoPID);
				m_pTsDemuxer->SetAudioPID(wAudioPID);
				return 0UL;
			}
			
			case CProgManager::EID_SERVICE_INFO_UPDATED : {
				// T[rX񂪍XVꂽ
				TCHAR szServiceName[1024] = {TEXT("s")};
				m_ProgManager.GetServiceName(szServiceName);
				return 0UL;
			}
		}
	} else if(pDecoder == m_pTsDemuxer){
	
		switch(dwEventID){
		
			case CTsDemuxer::EID_SERVICE_FIRST_AAC:					// ςȕ⊮B_VIDEOPTSɂ킹邽߁A𖄂߂
				{
					LONG hokan;
					LONGLONG diff;
					diff = m_pTsDemuxer->GetM2VAACDif();
					diff = diff * 48 * 4 / 90;
					hokan = (LONG)diff;
					hokan -= (hokan % 4);
					if(hokan > 1920000 || hokan < -1920000){
						TRACE(L"10bȏジĂB\n");
						break;
					}
					TRACE1("␳ : %d\n",hokan);
					if(hokan > 0){							// VideoxĂꍇ
						BYTE* dummy = new BYTE[hokan];
						ZeroMemory(dummy,hokan);

						CMediaData *m = new CMediaData(dummy, hokan);
						delete [] dummy;

//						m_FFmpgAudioBand.InputMedia(m);
						delete m;
					} else if (hokan < 0){					// Videoiłꍇ
						m_AacConverter.SetCutFrame((DWORD)(m_pTsDemuxer->GetM2VAACDif() *-1* 48 / 90));	// Video擪ɂ킹邽߂ɁA폜Audiot[ݒ
						m_pTsDemuxer->m_FirstAudioPts = m_pTsDemuxer->m_FirstVideoPts;			// 擪VIDEOƓ̂ŁAAudio̐擪PTSVIDEOƓɂ
					}
				}

				break;
			case CTsDemuxer::EID_SERVICE_M2V_COMMIT:
				{
					if(m_AacConverter.GetTotalSample() < 100000) break;

					LONGLONG pts_ms = m_pTsDemuxer->GetTotalVideoPts();
					LONGLONG frame_ms = (LONGLONG)m_pTsDemuxer->GetVideoTotalFrame() * 3003;		// * 1000 / 29.97(fps)   ms
					LONGLONG diff;

					diff = (pts_ms - frame_ms);

					if(diff >= 1 || diff <= -1){
						m_pTsDemuxer->m_FirstAudioPts += (LONGLONG)diff;		// 炩̌ŁAVideoĂB
						m_pTsDemuxer->m_FirstVideoPts += (LONGLONG)diff;		// ␳B
						TRACE((LPCTSTR)L"frame_ms:%I64d   , pts_ms:%I64d\n",frame_ms,pts_ms);
					}
				}
				break;
			case CTsDemuxer::EID_SERVICE_AAC_COMMIT:
				{

				if(m_AacConverter.GetTotalSample() < 100000) break;

//				log_out("AAC	%I64d	%I64d	%d\n",m_pTsDemuxer->m_NowVideoPts,m_pTsDemuxer->m_NowAudioPts,m_pAacConverter->GetTotalSample());

				LONGLONG diff;
				diff = (m_pTsDemuxer->GetTotalAudioPts() / 90 - m_AacConverter.GetTotalSample() / 48);	// PTS 90kHz Audio 48kHz 炵̂ŁAPʂmsɂ킹čƂB

//				m_AudioLpfBuf = 0.05 * diff + 0.95 * m_AudioLpfBuf;		// PESƎf[^̍LPFɒʂBW͓KBB
//				m_AudioLpfBuf = diff;

				if (diff > 5000 || diff < -5000){		// }2secȏ́A肷Ȃ̂ŋ炭G[Ă
					diff = 0;
					m_AacConverter.ResetTotalFrame();
					m_pTsDemuxer->ResetTotalAudioPts();
					m_pTsDemuxer->EnableLipSync(TRUE);
				} else {
					if (diff == 0){
						m_AacConverter.SetHoseiPol(0);
						m_AudHoseiFromVid = 0;
					} else if(diff >= 70){					// 2 frame ȏジĂ
						TRACE((LPCTSTR)L"diff : %dms\n",(LONG)diff);
						m_AacConverter.SetHoseiPol((LONG)4);				
						m_AudHoseiFromVid = 1;
					} else if (diff <= -70){			// -2 frameȏジĂ
						TRACE((LPCTSTR)L"diff : %dms\n",(LONG)diff);
						m_AacConverter.SetHoseiPol((LONG)-4);				
						m_AudHoseiFromVid = -1;
					} else if (m_AudHoseiFromVid < 0){	// 
						TRACE((LPCTSTR)L"diff : %dms\n",(LONG)diff);
						m_AacConverter.SetHoseiPol((LONG)-4);				
						m_AudHoseiFromVid = -1;
					} else if (m_AudHoseiFromVid > 0){
						TRACE((LPCTSTR)L"diff : %dms\n",(LONG)diff);
						m_AacConverter.SetHoseiPol((LONG)4);				
						m_AudHoseiFromVid = 1;
					}
				}

				m_AacConverter.ResetPesPerFrame();

				}
				break;
		}
	} else if(pDecoder == &m_FileReader){
		
		// t@C[_̃Cxg
		switch(dwEventID){
			case CFileReader::EID_READ_ASYNC_START :
				// 񓯊[hJn
				m_pEventHandler->OnTsConverterStart(m_FileReader.GetFileSize());
				return 0UL;
			
			case CFileReader::EID_READ_ASYNC_END :
				// 񓯊[hI
				CloseDecoders();
				m_pEventHandler->OnTsConverterEnd(m_FileReader.GetFileSize());
//				m_WaveSend.Close();
//				m_VideoSend.Close();
//				CloseFFmpeg();
				return 0UL;
			
			case CFileReader::EID_READ_ASYNC_POSTREAD :
				// 񓯊[h
				m_pEventHandler->OnTsConverterProgress(m_FileReader.GetReadPos(), m_FileReader.GetFileSize());
				return 0UL;
			}		
		}

	
	
	return 0UL;

}
